<?php

namespace FluentForm\App\Databases\Migrations;

class FormMeta
{
	
    /**
     * Migrate the table.
     *
     * @return void
     */
    public static function migrate()
    {
        global $wpdb;

        $charsetCollate = $wpdb->get_charset_collate();

        $table = $wpdb->prefix.'fluentform_form_meta';

        $formTable = $wpdb->prefix.'fluentform_forms';

        if ($wpdb->get_var("SHOW TABLES LIKE '$table'") != $table) {
            $sql = "CREATE TABLE $table (
			  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
			  `form_id` INT UNSIGNED NULL,
			  `meta_key` VARCHAR(255) NOT NULL,
			  `value` LONGTEXT NULL,
			  PRIMARY KEY (`id`),
			  INDEX `fluent_form_id_idx` (`form_id` ASC),
			  CONSTRAINT `fk_fluent_form_meta_form_id`
			    FOREIGN KEY (`form_id`)
			    REFERENCES $formTable (`id`)
			    ON DELETE CASCADE
			    ON UPDATE CASCADE) $charsetCollate;";

            require_once(ABSPATH.'wp-admin/includes/upgrade.php');

            dbDelta($sql);
        }
    }
}