<?php

namespace FluentForm\App\Databases\Migrations;

class FormTransactions
{
    /**
     * Migrate the table.
     *
     * @return void
     */
    public static function migrate()
    {
        global $wpdb;

        $charsetCollate = $wpdb->get_charset_collate();

        $table = $wpdb->prefix.'fluentform_transactions';

        $submissionsTable = $wpdb->prefix.'fluentform_submissions';

        $formTable = $wpdb->prefix.'fluentform_forms';

        if ($wpdb->get_var("SHOW TABLES LIKE '$table'") != $table) {
            $sql = "CREATE TABLE $table (
			  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
			  `form_id` INT UNSIGNED NULL,
			  `response_id` BIGINT(20) UNSIGNED NULL,
			  `currency` VARCHAR(45) NULL,
			  `charge_id` VARCHAR(45) NULL,
			  `card_type` VARCHAR(45) NULL,
			  `amount` VARCHAR(45) NULL,
			  `payment_method` VARCHAR(45) NULL,
			  `payment_status` VARCHAR(45) NULL,
			  `payment_type` VARCHAR(45) NULL,
			  `payer_email` VARCHAR(255) NULL,
			  `user_id` INT UNSIGNED NULL,
			  `created_at` TIMESTAMP NULL,
			  `updated_at` TIMESTAMP NULL,
			  PRIMARY KEY (`id`),
			  INDEX `form_id_idx` (`form_id` ASC),
			  INDEX `response_id_idx` (`response_id` ASC),
			  CONSTRAINT `fk_fluent_transactions_form_id`
			    FOREIGN KEY (`form_id`)
			    REFERENCES $formTable (`id`)
			    ON DELETE CASCADE
			    ON UPDATE CASCADE,
			  CONSTRAINT `fk_fluent_transactions_response_id`
			    FOREIGN KEY (`response_id`)
			    REFERENCES $submissionsTable (`id`)
			    ON DELETE CASCADE
			    ON UPDATE CASCADE ) $charsetCollate;";

            require_once(ABSPATH.'wp-admin/includes/upgrade.php');

            dbDelta($sql);
        }
    }
}