<?php

namespace FluentForm\App\Modules;

use FluentForm\App\Modules\Acl\Acl;
use FluentForm\App\Databases\DatabaseMigrator;

class Activator
{
	/**
	 * This method will be called on plugin activation
	 * @return void
	 */
	public function handleActivation()
	{
        // We are going to migrate all the database tables here.
		DatabaseMigrator::run();

		// Assign fluentform permission set.
        Acl::setPermissions();
        
        $this->setDefaultGlobalSettings();
        $this->setCurrentVersion();
	}
	
	private function setDefaultGlobalSettings()
	{
		if(!get_option('_fluentform_global_form_settings')) {
			update_option('__fluentform_global_form_settings', array(
				'layout' => array(
					'labelPlacement' => 'top',
					'helpMessagePlacement' => 'with_label',
					'errorMessagePlacement' => 'inline',
					'cssClassName' => ''
				)
			));
		}
	}
	
	private function setCurrentVersion()
	{
		update_option('_fluentform_installed_version', '1.3.4');
	}
}