<?php namespace FluentForm\App\Modules;

use FluentForm\App;
use FluentForm\View;

class DocumentationModule
{
	
	public function render()
	{
		wp_enqueue_style('fluentform_doc_style', fluentformMix('css/admin_docs.css'), array(), FLUENTFORM_VERSION);
		$userGuides = $this->getUserGuides();
		return View::make('admin.docs.index', array(
			'user_guides' => $userGuides,
			'icon_path_url' => App::publicUrl()
		));
	}
	
	private function getUserGuides()
	{
		$guides = array(
			array(
				'title' => 'Creating a Form',
				'link' => 'https://wpfluentform.com/guides/01-how-to-create-a-form-with-fluentform/'
			),
			array(
				'title' => 'Set up Form submission confirmation message',
				'link' => 'https://wpfluentform.com/guides/set-up-form-submission-confirmation-message/'
			),
			array(
				'title' => 'Form Layout Settings',
				'link' => 'https://wpfluentform.com/guides/form-layout-settings/'
			),
			array(
				'title' => 'Set up forms with Conditional logic',
				'link' => 'https://wpfluentform.com/guides/set-up-forms-with-conditional-logic/'
			),
			array(
				'title' => 'Managing the submitted entries',
				'link' => 'https://wpfluentform.com/guides/managing-the-submitted-entries/'
			),
			array(
				'title' => 'Setting up email notifications',
				'link' => 'https://wpfluentform.com/guides/setting-up-email-notification/'
			),
			array(
				'title' => 'MailChimp Integration',
				'link' => 'https://wpfluentform.com/guides/mailchimp-integration/'
			),
			array(
				'title' => 'Setting up form fields with restrictions',
				'link' => 'https://wpfluentform.com/guides/setting-up-form-fields-with-restrictions/'
			)
		);
		return apply_filters('fluentform_user_guide_links', $guides);
	}
}