<?php

namespace FluentForm\App\Modules\Form;

use FluentForm\App\Modules\Acl\Acl;
use FluentForm\Framework\Foundation\Application;

class Inputs
{
    /**
     * @var \FluentForm\Framework\Request\Request
     */
    private $request;

    /**
     * Build the class instance
     * @throws \Exception
     */
    public function __construct(Application $application)
    {
        Acl::verify('fluentform_forms_manager');

        $this->request = $application->request;
    }

    /**
     * Get all the flatten form inputs for shortcode generation.
     */
    public function index()
    {
        $formId = $this->request->get('formId');

        $deep = true;

        $form = wpFluent()->table('fluentform_forms')->find($formId);
		
        $fields = FormFieldsParser::getShortCodeInputs($form, ['admin_label', 'attributes', 'options']);
        wp_send_json($fields, 200);
    }
}
