<?php

namespace FluentForm\App\Services\FormBuilder\Components;

class Container extends BaseComponent
{
	/**
	 * Max columns for container
	 * @var integer
	 */
	protected $maxColumns = 12;

	/**
	 * Container column class
	 * @var string
	 */
	protected $columnClass = 'ff-t-cell';

	/**
	 * Container wrapper class
	 * @var string
	 */
	protected $wrapperClass = 'ff-t-container';

	/**
	 * Compile and echo the html element
	 * @param  array $data [element data]
	 * @param  stdClass $form [Form Object]
	 * @return viod
	 */
	public function compile($data, $form)
	{
		$columnClass = $this->columnClass;
		echo "<div class='{$this->wrapperClass}'>";
		if (isset($data['settings']['label'])) {
            echo "<strong>{$data['settings']['label']}</strong>";
        }
		foreach ($data['columns'] as $column) {
			echo "<div class='{$columnClass}'>";
			foreach ($column['fields'] as $item) {
				$item = $this->app->applyFilters('before_render_item', $item, $form);
				$this->app->doAction('render_item_'.$item['element'], $item, $form);
			}
			echo "</div>";
		}
		echo "</div>";
	}
}
