<?php

namespace FluentForm\App\Services\FormBuilder\Components;

class CustomHtml extends BaseComponent
{
	/**
	 * Compile and echo the html element
	 * @param  array $data [element data]
	 * @param  stdClass $form [Form Object]
	 * @return viod
	 */
	public function compile($data, $form)
	{
		$hasConditions = $this->hasConditions($data) ? 'has-conditions' : '';
		$cls = trim($this->getDefaultContainerClass() .' '.$hasConditions);
		$atts = $this->buildAttributes(
			\FluentForm\Framework\Helpers\ArrayHelper::except($data['attributes'], 'name')
		);
		echo "<div class='{$cls}' {$atts}>{$data['settings']['html_codes']}</div>";
	}
}
