<?php

namespace FluentForm\App\Services\FormBuilder\Components;

class DateTime extends BaseComponent
{
	/**
	 * Compile and echo the html element
	 * @param  array $data [element data]
	 * @param  stdClass $form [Form Object]
	 * @return viod
	 */
	public function compile($data, $form)
	{
		$this->enqueueStyleAndScripts();

        $data['attributes']['class'] = trim(
        	'ff-el-form-control '. $data['attributes']['class']
        );
        $data['attributes']['id'] = $this->makeElementId($data, $form);

		$elMarkup = "<input data-type-datepicker data-format='%s' %s>";

        $elMarkup = sprintf(
            $elMarkup,
            $data['settings']['date_format'],
            $this->buildAttributes($data['attributes'])
        );

		echo $this->buildElementMarkup($elMarkup, $data, $form);
	}

	/**
	 * Enqueue style and script for datetime element
	 * @return void
	 */
	protected function enqueueStyleAndScripts()
	{
		// Style
		wp_enqueue_style(
			'jquery-datetimepicker',
			$this->app->publicUrl('libs/jquery-datetimepicker/jquery.datetimepicker.min.css')
		);

		// Script
		wp_enqueue_script(
			'jquery-datetimepicker',
			$this->app->publicUrl('libs/jquery-datetimepicker/jquery.datetimepicker.full.min.js'),
			array('jquery'),
			false,
			true
		);
	}
}
