<?php

namespace FluentForm\App\Services\FormBuilder\Components;

class Name extends BaseComponent
{
	/**
	 * Compile and echo the html element
	 * @param  array $data [element data]
	 * @param  stdClass $form [Form Object]
	 * @return viod
	 */
	public function compile($data, $form)
	{
		$rootName = $data['attributes']['name'];
		$hasConditions = $this->hasConditions($data) ? 'has-conditions' : '';
		@$data['attributes']['class'] .= $hasConditions;
		$atts = $this->buildAttributes(
			\FluentForm\Framework\Helpers\ArrayHelper::except($data['attributes'], 'name')
		);

		echo "<div {$atts}>";
		echo "<div class='ff-t-container'>";

		foreach ($data['fields'] as $field) {
			if($field['settings']['visible']) {
				$fieldName = $field['attributes']['name'];
				$field['attributes']['name'] = $rootName.'['.$fieldName.']';
                @$field['attributes']['class'] = trim(
                    'ff-el-form-control '.
                    $field['attributes']['class']
                );
                $field['attributes']['id'] = $this->makeElementId($field, $form);

                $elMarkup = "<input %s>";
                $elMarkup = sprintf($elMarkup, $this->buildAttributes($field['attributes']));

                $inputTextMarkup = $this->buildElementMarkup($elMarkup, $field, $form);
                echo sprintf("<div class='%s'>{$inputTextMarkup}</div>",
                    'ff-t-cell'
                );
			}
		}
		echo"</div>";
		echo"</div>";
	}
}
