<?php

namespace FluentForm\App\Services\FormBuilder\Components;

class SectionBreak extends BaseComponent
{
	/**
	 * Compile and echo the html element
	 * @param  array $data [element data]
	 * @param  stdClass $form [Form Object]
	 * @return viod
	 */
	public function compile($data, $form)
	{
		$hasConditions = $this->hasConditions($data) ? 'has-conditions' : '';
		$cls = trim($this->getDefaultContainerClass().' '.$hasConditions);
		$data['attributes']['class'] = $cls .' '. $data['attributes']['class'];
		$data['attributes']['class'] = trim($data['attributes']['class']);
		$atts = $this->buildAttributes(
			\FluentForm\Framework\Helpers\ArrayHelper::except($data['attributes'], 'name')
		);
		echo "<div {$atts}>";
		echo "<label>{$data['settings']['label']}</label>";
		echo "<div>{$data['settings']['description']}</div>";
		echo "</div>";
	}
}
