<?php

namespace FluentForm\App\Services\FormBuilder\Components;

class SubmitButton extends BaseComponent
{
	/**
	 * Compile and echo the html element
	 * @param  array $data [element data]
	 * @param  stdClass $form [Form Object]
	 * @return viod
	 */
	public function compile($data, $form)
	{
        $align = 'ff-el-group ff-text-'.$data['settings']['align'];
        $data['attributes']['class'] = trim(
            'ff-btn ff-btn-submit ff-btn-primary ' .
            $data['attributes']['class']
        );
		$atts = $this->buildAttributes($data['attributes']);
		$cls = trim($align.' '.$data['settings']['container_class']);
		echo "<div class='{$cls}'>";

		// ADDED IN v1.2.6
		if (isset($data['settings']['button_ui'])) {
            if ($data['settings']['button_ui']['type'] == 'default') {
                echo '<button '.$atts.'>'.$data['settings']['button_ui']['text']
                    .'</button>';
            } else {
                echo "<button class='ff-btn-submit' type='submit'><img style='max-width: 200px;' src='{$data['settings']['button_ui']['img_url']}' alt='Submit Form'></button>";
            }
        } else {
            echo '<button '.$atts.'>'.$data['settings']['btn_text'].'</button>';
        }

		echo '</div>';
	}
}
