<?php

/**
 * element_settings_placement
 *
 * Returns an array of countries and codes.
 *
 * @author      WooThemes
 * @category    i18n
 * @package     fluentform/i18n
 * @version     2.5.0
 */


$element_settings_placement = array(
	'input_name'          => array(
		'general'  => array(
			'name',
			'name_fields',
		),
		'advanced' => array(
			'admin_field_label',
			'container_class',
			'conditional_logics',
		),
	),
	'input_email'         => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'validation_rules',
		),
		'advanced' => array(
			'admin_field_label',
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_text'          => array(
		'general'        => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'validation_rules',
		),
		'advanced'       => array(
			'admin_field_label',
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
		'generalExtras'  => array(),
		'advancedExtras' => array(),
	),
	'textarea'            => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'rows',
			'cols',
			'validation_rules',
		),
		'advanced' => array(
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'address'             => array(
		'general'  => array(
			'label',
			'name',
			'address_fields',
		),
		'advanced' => array(
			'admin_field_label',
			'class',
			'conditional_logics',
		),
	),
	'select_country'      => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'validation_rules',
		),
		'advanced' => array(
			'container_class',
			'class',
			'country_list',
			'help_message',
			'conditional_logics',
		),
	),
	'input_number'        => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'validation_rules',
		),
		'advanced' => array(
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'select'              => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'options',
			'validation_rules',
		),
		'advanced' => array(
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_radio'         => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'options',
			'validation_rules',
		),
		'advanced' => array(
			'container_class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_checkbox'      => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'options',
			'validation_rules',
		),
		'advanced' => array(
			'container_class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_url'           => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'validation_rules',
		),
		'advanced' => array(
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_password'      => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'validation_rules',
		),
		'advanced' => array(
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_date'          => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'placeholder',
			'date_format',
			'validation_rules',
		),
		'advanced' => array(
			'value',
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_file'          => array(
		'general'  => array(
			'label',
			'btn_text',
			'label_placement',
			'name',
			'validation_rules',
		),
		'advanced' => array(
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_image'         => array(
		'general'  => array(
			'label',
			'btn_text',
			'label_placement',
			'name',
			'validation_rules',
		),
		'advanced' => array(
			'container_class',
			'class',
			'help_message',
			'conditional_logics',
		),
	),
	'input_repeat'        => array(
		'general'  => array(
			'label',
			'label_placement',
			'name',
			'multi_column',
			'repeat_fields',
		),
		'advanced' => array(
			'container_class',
			'conditional_logics',
		),
	),
	'input_hidden'        => array(
		'general' => array(
			'name',
			'admin_field_label',
			'value',
		),
	),
	'section_break'       => array(
		'general'  => array(
			'label',
			'description',
			'align',
		),
		'advanced' => array(
			'class',
			'conditional_logics',
		),
	),
	'recaptcha'           => array(
		'general' => array(
			'label',
			'label_placement',
			'name',
			'validation_rules',
		),
	),
	'custom_html'         => array(
		'general' => array(
			'html_codes',
			'conditional_logics',
		),
	),
	'shortcode'           => array(
		'general'       => array(
			'shortcode',
		),
		'generalExtras' => array(
			'message' => array(
				'template' => 'infoBlock',
				'text'  => 'Hello',
			),
		),
		'advanced'      => array(
			'class',
			'conditional_logics',
		),
	),
	'terms_and_condition' => array(
		'general'  => array(
			'name',
			'validation_rules',
			'tnc_html',
			'has_checkbox',
		),
		'advanced' => array(
			'container_class',
			'class',
			'conditional_logics',
		),
	),
	'action_hook'         => array(
		'general'  => array(
			'hook_name',
		),
		'advanced' => array(
			'class',
			'conditional_logics',
		),
	),
	'form_step'           => array(
		'general' => array(
			'prev_btn',
			'next_btn',
			'class',
		),
	),
	'button'              => array(
		'general'       => array(
			'btn_text',
			'button_ui',
			'align',
		),
		'advanced'      => array(
			'container_class',
			'class',
			'help_message',
		),
		'generalExtras' => array(
			'btn_text' => array(
				'element'   => 'input',
				'type'      => 'text',
				'label'     => 'Button Text',
				'help_text' => 'Form submission button text.',
			),
		),
	),
	'step_start'          => array(
		'general' => array(
			'class',
			'progress_indicator',
			'step_titles',
		),
	),
	'step_end'            => array(
		'general' => array(
			'class',
			'prev_btn',
		),
	),
);

return apply_filters( 'fluent_editor_element_settings_placement', $element_settings_placement );