<?php

use FluentForm\App\Helpers\Helper;
use FluentForm\Framework\Helpers\ArrayHelper;

?>
<h2><?php _e('FluentForm Global Settings', 'fluentform'); ?></h2>
<div class="ff_form_wrap">
    <div class="ff_settings_wrapper">
        <?php do_action('fluentform_before_global_settings_wrapper'); ?>

        <div class="ff_settings_sidebar">
            <ul class="ff_settings_list">

                <li class="<?= Helper::getHtmlElementClass('settings', $currentComponent); ?>">
                    <a data-hash="settings"
                       href="<?= Helper::makeMenuUrl('fluent_forms_settings', [
                           'hash' => 'settings'
                       ]); ?>"
                    >
                        <?= __('Settings'); ?>
                    </a>
                </li>

                <?php foreach ($components as $component): ?>
                    <li class="<?= Helper::getHtmlElementClass($component['hash'], $currentComponent); ?>">
                        <a data-hash="<?php echo ArrayHelper::get($component, 'hash', ''); ?>"
                           href="<?php echo Helper::makeMenuUrl('fluent_forms_settings', $component); ?>"
                        >
                            <?php echo $component['title']; ?>
                        </a>
                    </li>
                <?php endforeach; ?>
            </ul>
        </div>

        <div class="ff_settings_container">
            <?php do_action('fluentform_global_settings_component_'.$currentComponent); ?>
        </div>

        <?php do_action('fluentform_after_global_settings_wrapper'); ?>
    </div>
</div>
